#include <windows.h>

#ifndef __E24_DLL__
#define __E24_DLL__


////////////////////////////////////////////////////////////////////////////////
//     
#define MDIN0     0     //  0 
#define MDIN1     1     //  1 
#define EXT_TEST  2     //   
#define INT_TEST  3     //   

////////////////////////////////////////////////////////////////////////////////
//  ;    
#define CODECALL  0xF   //   
#define CODEC0    1     //  0
#define CODEC1    2     //  1
#define CODEC2    4     //  2
#define CODEC3    8     //  3

////////////////////////////////////////////////////////////////////////////////
//     
#define KU1    0
#define KU2    1
#define KU4    2
#define KU8    3
#define KU16   4
#define KU32   5
#define KU64   6
#define KU128  7

////////////////////////////////////////////////////////////////////////////////
//  
#define NORMAL    0
#define AUTOCAL   1
#define EXTCAL0   2
#define EXTCALM   3
#define FULLCAL   4
#define FONCAL    5
#define INTCAL0   6
#define INTCALM   7

////////////////////////////////////////////////////////////////////////////////
//     
#define B2400     0
#define B4800     1
#define B9600     2
#define B19200    3
#define B38400    4
#define B57600    5

#ifdef __cplusplus
extern "C" {
#endif


//   -   
DWORD WINAPI _export SendCommand( DWORD hCom,   //  
                                  BYTE cmd,     //  
                                  WORD par,     //  
                                  DWORD length  //   1  3
                                );

//   
DWORD WINAPI _export ConfigE24Chan( DWORD hCom, //  
                                    WORD mode,  //    (MDIN0 ...)
                                    BYTE chan   //    (CODECALL ...)
                                  );

//     
DWORD WINAPI _export SetGain( DWORD hCom,       //  
                              WORD gain,        //  . 
                              WORD mode,        //  
                              BYTE chan         //  
                            );

//     
DWORD WINAPI _export RefreshParam( DWORD hCom,  //  
                                   BYTE chan    //       
                                 );

//   
DWORD WINAPI _export SetActiveChan( DWORD hCom, //  
                                    BYTE chan   //  
                                  );

//   7- 
DWORD WINAPI _export ResetCounter( DWORD hCom );

//       
DWORD WINAPI _export ConfigE24COM( DWORD hCom,
                                   BYTE baud    //      
                                 );

//    
DWORD WINAPI _export SetE24Rate( DWORD hCom,
                                 WORD code,    //    
                                 BYTE chan,    //  
                                 double *freq  //    
                               );

//   EEPROM
DWORD WINAPI _export SetEEPROMAddress( DWORD hCom,
                                       WORD Addr      // 
                                     );

//    EEPROM  
DWORD WINAPI _export GetEEPROMByte( DWORD hCom,
                                    BYTE *btret       //  
                                  );

//    EEPROM      SetEEPROMAddress
DWORD WINAPI _export SetEEPROMByte( DWORD hCom,
                                    BYTE bt           //  
                                  );

//        5  (  7-  )
DWORD WINAPI _export Set5byteMode( DWORD hCom );

//        4 
DWORD WINAPI _export Set4byteMode( DWORD hCom );

//    14      
//        
DWORD WINAPI _export GetParameters( DWORD hCom,
                                    BYTE *param
                                  );

//   5-     , ,  ,  
//     4-      5  ,   
//   
//        ,     err 1
DWORD WINAPI _export ConvertE24Block( DWORD hCom,     //  
                                      BYTE *Buf,      //    
                                      BYTE length,    //  
                                      long *ad_data,  //   
                                      BYTE *p,        // 
                                      BYTE *chan,     //  
                                      BYTE *counter,  // 
                                      BYTE *err       //    (1 - error)
                                    );

//          
//    
//   ,    ;   - 0xFFFFFFFF
//        FreeComPort   
DWORD WINAPI _export InitE24( char *Com,  //     ("COM2" ...)
                              BYTE Baud   //    
                            );

//          FIFO
DWORD WINAPI _export StopE24( DWORD hCom );

//  count      data
//     ReadFile
//       LabView
DWORD WINAPI _export ReadComData( DWORD hCom,
                                  BYTE *data,
                                  DWORD count
                                );

//   CloseHandle -  COM - 
void  WINAPI _export FreeComPort( DWORD hCom );

#ifdef __cplusplus
}
#endif

#endif
