#include "e24api.h"
#include <dos.h>

DWORD WINAPI _export SendCommand( DWORD hCom, BYTE cmd, WORD par, DWORD length )
{
   BYTE tmp[3]; DWORD ret,mask;
   tmp[0]=(par>>8)&0xFF; tmp[1]=par&0xFF; tmp[2]=cmd;
   if(length==1) tmp[0]=tmp[2];
   SetCommMask((HANDLE)hCom,EV_TXEMPTY);
   WriteFile((HANDLE)hCom,&tmp,length,&ret,NULL);
   WaitCommEvent((HANDLE)hCom,&mask,NULL);

   return ((ret==length) ? hCom:0xFFFFFFFF);
}


DWORD WINAPI _export ConfigE24Chan( DWORD hCom, WORD mode, BYTE chan )
{
   WORD par=WORD(mode&0xF);
   return SendCommand(hCom,0x90|chan,par,3L);
}

DWORD WINAPI _export SetGain(DWORD hCom, WORD gain, WORD mode, BYTE chan)
{
   WORD par=((mode&7)<<8)|(gain&7);
   return SendCommand(hCom,0xC0|chan,par,3);
}

DWORD WINAPI _export StopE24(DWORD hCom)
{
   DWORD ret=SendCommand(hCom,0xFF,0,1);
   sleep(1);
   PurgeComm((HANDLE)hCom,PURGE_TXCLEAR|PURGE_RXCLEAR);
   return ret;
}

DWORD WINAPI _export Set5byteMode(DWORD hCom){ return SendCommand(hCom,0xF6,0,1); }

DWORD WINAPI _export Set4byteMode(DWORD hCom){ return SendCommand(hCom,0xF7,0,1); }

DWORD WINAPI _export RefreshParam(DWORD hCom, BYTE chan){ return SendCommand(hCom,0xD0|chan,0,1); }

DWORD WINAPI _export SetActiveChan(DWORD hCom, BYTE chan){ return SendCommand(hCom,0x80|chan,0,1); }

DWORD WINAPI _export ResetCounter(DWORD hCom){ return SendCommand(hCom,0xE0,0,1); }

DWORD WINAPI _export ConfigE24COM(DWORD hCom, BYTE baud){ return SendCommand(hCom,0xE0|(baud&7),0x5A5A,3); }

DWORD WINAPI _export SetE24Rate(DWORD hCom, WORD code, BYTE chan, double *freq)
{
   WORD par;
   *freq=2457600/(128.0*code);
   par=((code&0xF000)>>4)|((code&0x0F00)>>8);
   if(SendCommand(hCom,0xA0|chan,par,3)==0xFFFFFFFF) return 0xFFFFFFFF;
   par=((code&0x00F0)<<4)|(code&0x000F);
   return SendCommand(hCom,0xB0|chan,par,3);
}

DWORD WINAPI _export SetEEPROMAddress(DWORD hCom, WORD Addr)
{
   WORD par=((Addr&0x00F0)<<4)|(Addr&0x000F);
   return SendCommand(hCom,0xF2,par,3);
}

DWORD WINAPI _export GetEEPROMByte(DWORD hCom, BYTE *btret)
{
   SendCommand(hCom,0xF1,0,1);
   unsigned char bt=0,bt1;
   DWORD ret;
   while((bt&0xF0)!=0xA0){ ReadFile((HANDLE)hCom,&bt,1,&ret,NULL); }
   ReadFile((HANDLE)hCom,&bt1,1,&ret,NULL);
   *btret=(bt1<<4)|(bt&0xF);
   return hCom;
}

DWORD WINAPI _export SetEEPROMByte(DWORD hCom, BYTE bt)
{
   WORD par=((WORD(bt)&0x00F0)<<4)|(WORD(bt)&0x000F);
   BYTE b;
   DWORD ret,rt;
   rt=SendCommand(hCom,0xF3,par,3);
   while((b&0xF0)!=0xB0){ ReadFile((HANDLE)hCom,&b,1,&ret,NULL); }
   return rt;
}

//int ConvertE24Block(BYTE *buf, long *ad_data, unsigned long *t, int *p, int *chan)
//{
//   *p=(buf[0]&0x40)>>6;
//   *chan=(buf[0]>>3)&3;
//   *ad_data=DWORD(buf[0]&7)|(DWORD(buf[1])<<3)|(DWORD(buf[2])<<10)|(DWORD(buf[3])<<17);
//   *t=(DWORD(buf[5])<<7)|(DWORD(buf[6])<<14)|DWORD(buf[4]);
//   *ad_data-=0x800000;
//}
DWORD WINAPI _export ConvertE24Block( DWORD hCom,
                                      BYTE *buf,
                                      BYTE length,
                                      long *ad_data,
                                      BYTE *p,
                                      BYTE *chan,
                                      BYTE *counter,
                                      BYTE *err)
{

   *p=(buf[0]&0x40)>>6;
   *chan=(buf[0]>>4)&3;
   *ad_data=DWORD((buf[3]>>1)&0x3F)|(DWORD(buf[2])<<6)|(DWORD(buf[1])<<13)|(DWORD(buf[0]&0xF)<<20);
   *ad_data-=0x800000;
   if(length==5) *counter=buf[4]; else *counter=0xFF;
   *err=!(buf[0]&0x80);
   return hCom;
}

DWORD WINAPI _export GetParameters(DWORD hCom, BYTE *param)
{
   if(SendCommand(hCom,0xF5,0,1)==0xFFFFFFFF) return 0xFFFFFFFF;
   return ReadComData(hCom,param,14);
}

DWORD WINAPI _export InitE24( char *Com, BYTE Baud )
{
   DCB dcb;
   BOOL fSuccess;
   DWORD ComBaud;
   HANDLE hCom;
   hCom = CreateFile( Com, GENERIC_READ | GENERIC_WRITE,
                      0,               // comm devices must be opened w/exclusive-access
                      NULL,            // no security attrs
                      OPEN_EXISTING,   // comm devices must use OPEN_EXISTING
                      0,               // not overlapped I/O
                      NULL             // hTemplate must be NULL for comm devices
                    );
   if (hCom == INVALID_HANDLE_VALUE) return 0xFFFFFFFF;

   GetCommState(hCom,&dcb);

   dcb.BaudRate =19200;
   dcb.ByteSize = 8;
   dcb.Parity = NOPARITY;
   dcb.StopBits = ONESTOPBIT;
   dcb.fDtrControl = DTR_CONTROL_DISABLE;
   dcb.fRtsControl = RTS_CONTROL_DISABLE;
   fSuccess = SetCommState( hCom, &dcb);
   if(!fSuccess) return 1;     // fail

   PurgeComm(hCom,PURGE_TXCLEAR|PURGE_RXCLEAR);

   dcb.BaudRate = 19200;
   dcb.ByteSize = 8;
   dcb.Parity = NOPARITY;
   dcb.StopBits = ONESTOPBIT;
   dcb.fDtrControl = DTR_CONTROL_DISABLE;
   dcb.fRtsControl = RTS_CONTROL_ENABLE;
   fSuccess = SetCommState( hCom, &dcb);
   if(!fSuccess) return 1;   // fail

   unsigned char data[4]; DWORD ret=0;

   COMMTIMEOUTS TO,TOPREV;
   TO.ReadIntervalTimeout=0;
   TO.ReadTotalTimeoutMultiplier=2000;
   TO.ReadTotalTimeoutConstant=1000;
   TO.WriteTotalTimeoutMultiplier=0;
   TO.WriteTotalTimeoutConstant=0;

   GetCommTimeouts( hCom,&TOPREV);
   SetCommTimeouts( hCom,&TO);

   ReadFile( hCom,&data,4,&ret,NULL); // we wait while E24 loaded from EEPROM and start work

   SetCommTimeouts( hCom,&TOPREV);

   switch(Baud)
   {
   case 0: ComBaud=2400;break;
   case 1: ComBaud=4800;break;
   case 2: ComBaud=9600;break;
   case 3: ComBaud=19200;break;
   case 4: ComBaud=38400;break;
   case 5: ComBaud=57600;break;
   default: ComBaud=19200;
   }

   ConfigE24COM((DWORD)hCom, Baud);

   sleep(1);

   dcb.BaudRate = ComBaud;
   dcb.ByteSize = 8;
   dcb.Parity = NOPARITY;
   dcb.StopBits = ONESTOPBIT;
   dcb.fDtrControl = DTR_CONTROL_DISABLE;
   dcb.fRtsControl = RTS_CONTROL_ENABLE;
   fSuccess = SetCommState( hCom, &dcb);
   if(!fSuccess) return 1;   // fail

   StopE24((DWORD)hCom);
   PurgeComm(hCom,PURGE_TXCLEAR|PURGE_RXCLEAR);
   SetActiveChan((DWORD)hCom,CODECALL);

   return ((ret==4) ? (DWORD)hCom:0xFFFFFFFF);  // return hCom if ok
}

DWORD WINAPI _export ReadComData(DWORD hCom, BYTE *data, DWORD count)
{
   DWORD ret;
   ReadFile((HANDLE)hCom,data,count,&ret,NULL);
   return ((ret==count) ? (DWORD)hCom:0xFFFFFFFF);  // return hCom if ok
}

void WINAPI _export FreeComPort(DWORD hCom)
{
   CloseHandle((HANDLE)hCom);
}

BOOL WINAPI DllEntryPoint(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:
      break;

    case DLL_PROCESS_DETACH:
      break;

    case DLL_THREAD_ATTACH:
      break;

    case DLL_THREAD_DETACH:
      break;
  }
  return TRUE;
}



