#include <stdio.h>                            /* FOURIER CONVERSION */
#include <math.h>                             /*  Working version.  */

static int n,log_a;
static int arr_n[13]={1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096};
extern float *er, *ei, *dre, *dim, *sre, *sim;

fourier(float *inp, float *out, int size)
/********************************************************************/
/*	inp - 室 ᫥⥫쭮 ࠧ୮ size				*/
/*	out - ࣥ᪨ ᯥ ࠧ୮ size/2					*/
/*  size- ࠧ୮ 室 ᫥⥫쭮, ⭠ ⥯ 2	*/
/********************************************************************/
/*  ࢠ ମ 室  ன 窥 (out[1])             */
/*     (out[0])  ,   㤥 ࠢ쭮	*/
/********************************************************************/
/*   맮 ⮩ 楤  楤 ffrt(), 室       */
/*  맢 楤 initfft(size),  ᨢ  ffrt() */
/********************************************************************/
{
double f;
int i, k, max;

/* ⠭ ⥯  										*/
for(i=0; i < 13; i++)
	if(arr_n[i] == size)
	       {
		log_a=i;
		break;
		   }

/*	 ᨢ ⢨⥫쭮    室			*/
/*	᫥⥫쭮 												*/
for ( i=0; i < size; i++ )
      {
       dre[i] = inp [i];
       dim[i] = 0.0;
      }

n = size;

/*	맮 楤 												*/
fftrt();

n/=2;

/*	⠥ ࣥ᪨ ᯥ									*/
for(i=0; i < n; i++)
	out[i]=sqrt(dre[i]*dre[i] + dim[i]*dim[i])/n;
return (n);
}
/*****************************/

/********************************************************************/
/* 楤 ண ८ࠧ                           */
/* ᯮ ᨢ double *er, *ei, *dre, *dim, *sre, *sim   	*/
/* ࠧ୮ size/2                                               */
/*  뤥    ᨢ 室     */
/********************************************************************/
fftrt()
{
int a, b, c, d, e, f, h, l, i, j, k, n1,z;
double re, im;
double ere,eim;

n1 = n / 2;
for ( j=1; j <= log_a; j++ )
  {
  h = ( n >> j );
  l = ( 1 << (j-1) );
   for ( i=0; i < l; i++ )
	 {
	 e = i * h;
	 f = ( e << 1 );
	 ere = er[e];
	 eim = ei[e];
	  for ( k=0; k < h; k++ )
		{
		a = k + e;
		d = a + n1;
		b = k + f;
		c = b + h;
		re = dre[c] * ere + dim[c] * eim;
		im = dim[c] * ere - dre[c] * eim;
		sre[a] = dre[b] + re;
		sim[a] = dim[b] + im;
		sre[d] = dre[b] - re;
		sim[d] = dim[b] - im;
		}
	 }
   for ( z=0; z < n; z++ )
	 {
	 dre[z] = sre[z];
	 dim[z] = sim[z];
	 }
  }
}

initfft(int k)
{
double rad;
int i;

k/=2;
rad = M_PI / ((double)k);

for ( i=0; i <= k; i++ )
	{
	 er[i] = cos(rad*(double )i);
	 ei[i] = sin(rad*(double )i);
	}
}
