#include <dos.h>
#include <io.h>
#include <math.h>
#include <alloc.h>
#include <conio.h>
#include <ctype.h>
#include <process.h>
#include <stdio.h>
#include <fcntl.h>
#include "e24_test.h"
#include "ui_attr.h"

/* ⠭ ⨯ 		*/
#define RECT_WINDOW		0
#define HANN_WINDOW		1
#define	HAMMING_WINDOW		2
#define BLACKMAN_WINDOW		3
#define BARLETTE_WINDOW 	4
#define BLACKMAN_HARRIS_WINDOW 	5
extern int DACMask;
int WindowType=5;
int FftChan;
extern double FreqkHz, FRate;
double RealFreq;

extern double RealRate[15];
extern double RealScale[];
extern int RateScale, Rate;

extern long	*ChanData[4];
extern int ENABLE_MUX, Ad73311On;

double RightSpektr=1000;
int N_SPEKTR=128, Multi;
float *er, *ei, *dre, *dim, *sre, *sim;
extern int Chan, InputMode, *Buffer, Dac, Nch;
FingSNR(float *ptr, int N, float max);

double SNR_parm, EOB_parm;
long MaxSpektr=0x800000;

FillBpfWindow(float *ptr, int n, int type, float WindowAmpl);

SpektrPanel()
{
int i, j, k, n, key, hnd, cnt, key_flag, reset_loop=0, Pnl, again;
float max, f, SinusMax;
double garm;

RightSpektr=FRate/2.;

Pnl=LoadPanel("e24_test.uir", SPEKTR);
SetCtrlVal(Pnl, SPEKTR_MAX, MaxSpektr);
SetCtrlVal(Pnl, SPEKTR_RIGHT, RightSpektr);
SetCtrlVal(Pnl, SPEKTR_WINDOW, WindowType);
SetCtrlVal(Pnl, SPEKTR_CHAN, FftChan);
InstallPopup(Pnl);


for(key=again=0; !key;)
  {
  GetPopupEvent(1, &cnt);
again:
  switch(cnt)
    {
    case SPEKTR_DONE:
		key=1;
		break;

    case SPEKTR_MAX:
    	GetCtrlVal(Pnl, SPEKTR_MAX, &MaxSpektr);
    	break;

    case SPEKTR_WINDOW:
    	GetCtrlVal(Pnl, SPEKTR_WINDOW, &WindowType);
		break;

	case SPEKTR_CHAN:
		GetCtrlVal(Pnl, SPEKTR_CHAN, &FftChan);
		break;

    case SPEKTR_RIGHT:
		GetCtrlVal(Pnl, SPEKTR_RIGHT, &RightSpektr);
		break;

	case SPEKTR_SPEKTR:
		er=malloc(N_SPEKTR*4);
		ei=malloc(N_SPEKTR*4);
		dre=malloc(N_SPEKTR*4);
		dim=malloc(N_SPEKTR*4);
		sre=malloc(N_SPEKTR*4);
		sim=malloc(N_SPEKTR*4);

		for(i=0; i < N_SPEKTR; i++) dre[i]=ChanData[FftChan][i];
		for(i=SinusMax=0; i < N_SPEKTR/2; i++)
			if(fabs(dre[i]) > SinusMax) SinusMax=fabs(dre[i]);
		if(sim != NULL)
		  {
		  initfft(N_SPEKTR);
		  FillBpfWindow(dre, N_SPEKTR, WindowType, 1.0);
		  fourier(dre, dre, N_SPEKTR);

		  ConfigureAxes(Pnl, SPEKTR_GRAPH, 0, 0.0, RightSpektr,
				0, -180.0, -80.);
		  SetGraphAttribute(Pnl, SPEKTR_GRAPH, ATTR_GRAPH_Y_AXIS_DIVISIONS, 6);
		  for(i=max=0; i < N_SPEKTR/2; i++) if(dre[i] > max) max=dre[i];
		  if(max < 0.00001) break;
		  if(MaxSpektr) max=MaxSpektr;
		  FingSNR(dre, N_SPEKTR/2, SinusMax);
		  for(i=0; i < N_SPEKTR/2; i++)
			{
			f=(dre[i] < 0.0000001) ? 0.0000001 : dre[i];
				if(f/max < 0.0000000001) f=-1; else f=20.*log10(f/max);
			dre[i]=f;
			}

			  SetCtrlVal(Pnl, SPEKTR_ENB, EOB_parm);
			  SetCtrlVal(Pnl, SPEKTR_SNR, SNR_parm);
			  DeletePlots(Pnl, SPEKTR_GRAPH);
		  PlotWaveform (Pnl, SPEKTR_GRAPH, dre, N_SPEKTR/2, 3, 1.0, 0.0,
		  0.0, FRate/N_SPEKTR, 0, 0, 0, BLACK);
		  delay(400);
		  }
		else
		 {
		 MessagePopup("No Memory");
		 if(er) free(er);
		 if(ei) free(ei);
		 if(dre) free(dre);
		 if(dim) free(dim);
		 if(sre) free(sre);
		 if(sim) free(sim);
		 break;
		 }

		free(sim);
		free(sre);
		free(dim);
		free(dre);
		free(ei);
		free(er);
		break;
	}
  }

RemovePopup(Pnl);
UnloadPanel(Pnl);
}

FillBpfWindow(float *ptr, int n, int type, float WindowAmpl)
{
int i;
double f;

switch(type)
  {
  case RECT_WINDOW:
	for(i=0; i < n; i++) ptr[i]*=WindowAmpl;
	break;

  case HANN_WINDOW:
	for(i=0; i < n; i++)  { f=0.5*(1.-cos(2.*M_PI*(double)i/(double)n));
				ptr[i]*=f*WindowAmpl; }
	break;

  case HAMMING_WINDOW:
	for(i=0; i < n; i++)  { f=0.54-0.46*cos(2.*M_PI*(double)i/(double)n);
				ptr[i]*=f*WindowAmpl; }
	break;

  case BLACKMAN_WINDOW:
	for(i=0; i < n; i++) { f=0.42-0.5*cos(2.*M_PI*(double)i/(double)n)+
				 0.08*cos(4.*M_PI*(double)i/(double)n);
			       ptr[i]*=f*WindowAmpl;}
	break;

  case BARLETTE_WINDOW:
	for(i=0; i < n; i++) { f=(i <= (n-1)/2) ? 2.*(double)i/(double)n
				 : 2.-2.*(double)i/(double)n;
			       ptr[i]*=f*WindowAmpl; }
	break;
  case BLACKMAN_HARRIS_WINDOW:
	for(i=0; i < n; i++) { f=0.35875-0.48829*cos(2.*M_PI*(double)i/
				 (double)n)+0.14128*cos(4.*M_PI*(double)i/
				 (double)n)-0.01168*cos(6.*M_PI*(double)i/
				 (double)n);
			       ptr[i]*=f*WindowAmpl; }
	break;
  }
}



#define MAX_PEAK_WIDTH 5
FingSNR(float *ptr, int N, float max)
{
int i, j, k, n, index, l=0, r=0;
double f, f1, f2, f3, lmax;

if(!MaxSpektr)
  {
  for(i=lmax=index=0; i < N; i++) if(ptr[i] > lmax) { lmax=ptr[i]; index=i; }

  for(f=lmax, l=r=i=index; ;)
    {
//    if(f >= max) break;

    if(l > 0) { l--; f+=ptr[l]; }
    if(r < N-1) { r++; f+=ptr[r]; }

    if(l <=0 && r >= N-1) break;
    if(l < index-MAX_PEAK_WIDTH) break;
    if(r > index+MAX_PEAK_WIDTH) break;
    }
  }
 else max=MaxSpektr;

#define START_NUM 6
  for(f=0, i=START_NUM; i < N; i++) if(i < l || i > r) f+=ptr[i]*ptr[i];
  f=sqrt(f);

if(f < 0.00000001) f=0.0000001;
//f=0.33979;
if(max/f < 0.000001)
  {
  SNR_parm=-1;
  EOB_parm=-1;
  return;
  }

SNR_parm=20.*log10(max/f);
EOB_parm=(SNR_parm-1.76)/6.02;

if(EOB_parm < 8)
  i=5;
}
